package linearalgebra.numeric;


public interface NumericMatrixInterface 
	extends linearalgebra.MatrixInterface, Cloneable {
	
	// scalar operations
	public NumericMatrixInterface multiply( double scalar );
	public NumericMatrixInterface multiplyEquals( double scalar );
	public void multiplyRow( int row, double scalar );
	public void combineRows( int srcRow, int dstRow, double scalar );

	// arithmetic operations
	public NumericMatrixInterface plus( NumericMatrixInterface m );
	public NumericMatrixInterface plusEquals( NumericMatrixInterface m );
	public NumericMatrixInterface minus( NumericMatrixInterface m );
	public NumericMatrixInterface minusEquals( NumericMatrixInterface m );
	// plus equals cannot be general because a numeric matrix might get a symbolic matrix
	public NumericMatrixInterface product( NumericMatrixInterface right );
	public NumericMatrixInterface power( int power );

	// element operations
    public void incrementElement(int row, int col, double value);
    public void scaleElement(int row, int col, double scalar);
	public double getElement( int row, int col );
    public void setElement(int row, int col, double element);

	// deconstruction operations
	public NumericColumnInterface getNumericColumnView( int colIndex );
	public NumericRowInterface getNumericRowView( int rowIndex );
	
	public Object clone();
}