package linearalgebra.numeric;


public class SingleElementVector extends AbstractNumericVector {
	private NumericVectorInterface m_vector;
	private int m_index;
	
	public SingleElementVector( NumericVectorInterface proxy, int index ) {
		m_vector = proxy;
		m_index = index;
	}
	
	
    public final Object clone() {
    	NumericVector rc = new NumericVector(new double[] {getValue(0)});
        return rc;
    }
    
    public final double[] toArray() {
    	return new double[] { m_vector.getValue(m_index) };
    }

    public final int getDimension() {
        return 1;
    }

    public final double getValue(int index) {
    	if( index != 0 ) {
    		throw new ArrayIndexOutOfBoundsException();
    	}
        return m_vector.getValue(m_index);
    }

    public final void setValue(int index, double value) {
    	if( index != 0 ) {
    		throw new ArrayIndexOutOfBoundsException();
    	}
    	m_vector.setValue(m_index, value);
    }
    
    public final void setValue( NumericVectorInterface v ) {
		if( v.getDimension() != getDimension() ) {
			throw new linearalgebra.exception.SizeMismatchError("Vector sizes do not match. Vector cannot copy values.");
		}
		for( int i = 0; i < getDimension(); i++ ) {
			setValue(i, v.getValue(i));
		}
    }
}