package linearalgebra.symbolic;

import java.util.ArrayList;

public abstract class AbstractUnknown implements linearalgebra.symbolic.SymbolicValue {
    public final SymbolicValue scale(SymbolicValue v) {
		return new Multiplication(v, this);
    }
	
	public boolean isNormal() {
		int order = getPrecedence();
		for( int i = 0; i < getChildCount(); i++ ) {
			if( getChild(i).getPrecedence() > order ) {
				return false;
			}
		}
		for( int i = 0; i < getChildCount(); i++ ) {
			if( getChild(i).isNormal() == false ) {
				return false;
			}
		}
		return true;
	}
/*	
	public int getPrecedence();
	
	public int getChildCount();
	
	public SymbolicValue getChild( int index );
*/
	private ArrayList<SymbolicValue> m_parents = new ArrayList<SymbolicValue>();
	public final int getParentCount() {
		return m_parents.size();
	}
	
	public final void addParent( SymbolicValue parent ) {
		m_parents.add( parent );
	}
	
	public final void removeParent( SymbolicValue parent ) {
		m_parents.remove( parent );
	}
	
	public final SymbolicValue getParent( int index ) {
		return m_parents.get(index);
	}
	
	private SymbolicValue containsNodeCache = null;
	private boolean containsAnswerCache = false;
	public boolean contains( SymbolicValue v, SymbolicValue parent ) {
		if( v == null ) {
			throw new Error( "contains() cannot search for a null value" );
		}
		if( v == containsNodeCache ) {
			return containsAnswerCache;
		}
		
		containsNodeCache = v;
		if( v == this ) {
			containsAnswerCache = true;
			return containsAnswerCache;
		}
		for( int i = 0; i < getChildCount(); i++ ) {			
			if( getChild(i).contains(containsNodeCache, this) ) {
				containsAnswerCache = true;
				return containsAnswerCache;
			}
		}
		containsAnswerCache = true;
		return containsAnswerCache;
	}
	
	public void subTreeChanged() {
		containsNodeCache = null;		
		for( int i = 0; i < getParentCount(); i++ ) {
			getParent(i).subTreeChanged();
		}
	}
	
    protected final void appendParenthesisString( SymbolicValue v, StringBuffer str ) {
    	if( v.getPrecedence() > getPrecedence() ) {
    		str.append("( ");
    		str.append( v.toString() );
    		str.append(" )");
    	} else {
    		str.append( v.toString() );
    	}
    }    
}