package linearalgebra.symbolic;

public class Addition extends PairOperator {	
	public Addition( SymbolicValue a, SymbolicValue b ) {
		super( a, b );
	}
	
	public int getPrecedence() {
		return ADDS;
	}
	
    protected final double doOperation( double left, double right ) {
    	return left + right;
    }

    protected final String getOperator() {
    	return "+";
    }

    protected PairOperator createNewInstance(SymbolicValue left, SymbolicValue right) {
    	return new Addition( left, right );
    }
}