package linearalgebra.symbolic;

import linearalgebra.exception.OverdeterminedSystemError;

public class ConstantSymbol extends LeafUnknown {
	private double m_value;
	
	public ConstantSymbol( double value ) {
		m_value = value;
	}
	
    public double getNumericValue() {
    	return m_value;
    }
    
	public void solveFor( double y ) {
		if( y != getNumericValue() ) {
			throw new OverdeterminedSystemError("ConstantSymbol has no unbound symbols, and y is not equal to value.");
		}
	}
	
	public String toString() {
		return Double.toString(m_value);
	}
	
}